<?php

class arf_dig_pro_user_products {

	function __construct() {

		add_action( 'wp_ajax_arf_dig_pro_user_product_bulk_act', array( $this, 'arf_dig_pro_user_product_bulk_act' ) );	

		add_action( 'wp_ajax_arf_dig_pro_delete_user_product', array( $this, 'arf_dig_pro_single_delete_user_product' ) );
	}

	function arf_dig_pro_get_user_payment_detail( $payment_option, $form_id, $entry_id, $download_id ) {
		global $wpdb;

		if ( empty( $form_id ) || empty( $entry_id ) || empty( $download_id ) ) {
			return false;
		}

		$as__transaction     = array();
		$as__payment_options = maybe_unserialize( $payment_option );

		if ( ! empty( $as__payment_options ) ) {
			foreach ( $as__payment_options as $payment_type => $payment ) {

				if ( $payment_type == 'paypal' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = esc_html__( 'Paypal', 'ARForms-Digital-Product' );

						$as__paypal_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_paypal_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );

						if ( $as__paypal_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__paypal_data->txn_id;
							if ( isset( $as__paypal_data->payment_type ) and $as__paypal_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_data->payment_type ) and $as__paypal_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__paypal_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__paypal_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__paypal_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__paypal_data->created_at ) && ! empty( $as__paypal_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__paypal_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'paypal_pro' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = esc_html__( 'Paypal Pro', 'ARForms-Digital-Product' );
						$as__paypal_pro_data                               = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_paypalpro_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						if ( $as__paypal_pro_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__paypal_pro_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__paypal_pro_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__paypal_pro_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__paypal_pro_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__paypal_pro_data->created_at ) && ! empty( $as__paypal_pro_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__paypal_pro_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'authorize_net' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = esc_html__( 'Authorize Net', 'ARForms-Digital-Product' );
						$as__authorize_net_data                            = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_authorizenet_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						if ( $as__authorize_net_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__authorize_net_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__authorize_net_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_pro_data->payment_type ) and $as__authorize_net_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__authorize_net_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__authorize_net_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__authorize_net_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__authorize_net_data->created_at ) && ! empty( $as__authorize_net_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__authorize_net_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'stripe' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = esc_html__( 'Stripe', 'ARForms-Digital-Product' );
						$as__stripe_data                                   = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_stripe_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						if ( $as__stripe_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__stripe_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__stripe_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__stripe_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__stripe_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__stripe_data->created_at ) && ! empty( $as__stripe_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__stripe_data->created_at ) ) : '';
						}
					}
				}
			}
		}
		return $as__transaction;
	}

	function arf_dig_pro_user_product_bulk_act() {

		if ( ! isset( $_POST ) ) {
			return;
		}
		global $arfform,$armainhelper;

		$bulkaction = $armainhelper->get_param( 'action1' );

		$message = '';

		$errors = array();

		if ( $bulkaction == -1 ) {
			$bulkaction = $armainhelper->get_param( 'action2' );
		}

		if ( ! empty( $bulkaction ) and strpos( $bulkaction, 'bulk_' ) === 0 ) {

			if ( isset( $_GET ) and isset( $_GET['action1'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action1'], '', $_SERVER['REQUEST_URI'] );
			}

			if ( isset( $_GET ) and isset( $_GET['action2'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action2'], '', $_SERVER['REQUEST_URI'] );
			}

			$bulkaction = str_replace( 'bulk_', '', $bulkaction );
		} else {

			$bulkaction = '-1';

			if ( isset( $_POST['bulkaction'] ) and $_POST['bulkaction1'] != '-1' ) {
				$bulkaction = $_POST['bulkaction1'];

			} elseif ( isset( $_POST['bulkaction2'] ) and $_POST['bulkaction2'] != '-1' ) {
				$bulkaction = $_POST['bulkaction2'];
			}
		}

		$ids = $armainhelper->get_param( 'item-action', '' );

		if ( empty( $ids ) ) {
			$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-Digital-Product' );
		} else {
			if ( ! is_array( $ids ) ) {
				$ids = explode( ',', $ids );
			}

			if ( is_array( $ids ) ) {
				if ( $bulkaction == 'delete' ) {
					foreach ( $ids as $fid ) {
						$res_var = $this->arf_dig_pro_delete_user_product( $fid );
					}
					if ( $res_var ) {
						$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
					}
				} else {
					$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-Digital-Product' );
				}
			}
		}
		$arf_dig_pro_user_product_data = $this->arf_dig_product_user_product_listing( $message, $errors );

		echo json_encode(
			array(
				'errors'   => $errors,
				'message'  => $message,
				'gridData' => $arf_dig_pro_user_product_data,
			)
		);

		die();
	}


	function arf_dig_product_user_product_listing( $message = '', $errors = array() ){

		global $wpdb ,$arf_dig_pro_user_products_class ,$arf_digital_product_download_tbl ,$arf_digital_product_tbl;

		$as___payment = array();

		$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-Digital-Product' );

		$products_bulk = $wpdb->get_results( 'SELECT D.*,P.options FROM ' . $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id ORDER BY D.id DESC' );
				
		$product_data_bulk_download = array();

		if ( count( $products_bulk ) > 0 ) {			
			$n = 0;
			foreach ( $products_bulk as $products ) {

				$options      = maybe_unserialize( $products->options );

				$as___payment = $arf_dig_pro_user_products_class->arf_dig_pro_get_user_payment_detail( $products->payment_options, $products->form_id, $products->entry_id, $products->id );

				if ( ! isset( $product_data_bulk_download[ $n ] ) ) {
					$product_data_bulk_download[ $n ] = array();
				}

				$product_data_bulk_download[ $n ][] = '<div class="arf_custom_checkbox_div">
				<div class="arf_custom_checkbox_wrapper">
					<input id="cb-item-action-' . $products->id .'" class="" type="checkbox" value="' .$products->id .'" name="item-action[]"><svg width="18px" height="18px">'.ARF_CUSTOM_UNCHECKED_ICON . ARF_CUSTOM_CHECKED_ICON .'</svg></div></div><label for="cb-item-action-' . $products->id . '"><span></span></label>';

				$product_data_bulk_download[ $n ][] = $products->id;
				$product_data_bulk_download[ $n ][] = $products->product_id;
				$product_data_bulk_download[ $n ][] = $products->form_id;
				$product_data_bulk_download[ $n ][] = $products->entry_id;
				$product_data_bulk_download[ $n ][] = isset( $as___payment[$products->id]['txn_id'] ) ? esc_html( $as___payment[$products->id]['txn_id'] ) : ''; 

				$product_data_bulk_download[ $n ][] = '<a class="row-title" href="'. esc_url( wp_nonce_url( '?page=ARForms-DigitalProduct&arfaction=edit&id='. $products-> product_id ) ).'">'. $options['arf_product_name'] .'</a>';


				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['payment_type'] ) ? esc_html( $as___payment[ $products->id ]['payment_type'] ) : ''; 
				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['payment_method'] ) ? esc_html( $as___payment[ $products->id ]['payment_method'] ) : ''; 
			
 				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['total_amount'] ) ? esc_html ( $as___payment[ $products->id ]['total_amount'] ) . '&nbsp;' . esc_html( $as___payment[ $products->id ]['currency'] ) : ''; //amount


				$product_data_bulk_download[ $n ][] = ( isset( $as___payment[ $products->id ]['payment_status'] ) && isset( $as___payment[ $products->id ]['currency'] ) ) ? esc_html( $as___payment[ $products->id ]['payment_status'] ) : ''; //status

				$product_data_bulk_download[ $n ][] = date( get_option( 'date_format' ), strtotime( $products->created_at ) );

				$edit_link = '?page=ARForms-DigitalProduct&arfaction=edit&id=' . $products->id;

				$arf_action_div_history = '<div class="arf-row-actions arf_digpro_action_cell " >';

				$arf_action_div_history .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Configuration', 'ARForms-Digital-Product' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";

				$arf_action_div_history .= "<div class='arfformicondiv arfhelptip  arfdeleteform_div_" . $products->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  id='delete_product'  data-id='" . $products->id . "' class='arfdeleteproduct'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

				$arf_action_div_history .= "<div id='view_entry_detail_container_{$products->id}' class='arf_display_none'>" . $arf_dig_pro_user_products_class->arf_dig_pro_get_download_history_entries_list( $products, $as___payment ) . "</div><div class='arfmnarginbtm10 arf_digpro_clear_both'></div>";

				$arf_action_div_history .= '</div>';

				$product_data_bulk_download[ $n ][] = $arf_action_div_history;

				$n++;
	}
}
	return $product_data_bulk_download;
}

	function arf_dig_pro_user_product_listing( $message = '', $errors = array() ) {
		global $wpdb, $arf_dig_pro_user_products_class;
		$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-Digital-Product' );
		if ( file_exists( ARF_DIG_PRO_VIEWS_DIR . '/arf_dig_pro_download_product_listing_3.0.php' ) ) {
			require_once ARF_DIG_PRO_VIEWS_DIR . '/arf_dig_pro_download_product_listing_3.0.php';
		}
	}

	function arf_dig_pro_single_delete_user_product() {
		
		$id     = $_POST['id'];
		$action = $_POST['act'];
		$errors = array();

		if ( $action == 'delete' && $id ) {

			$res     = $this->arf_dig_pro_delete_user_product( $id );

			if ( ! $res ) {
				$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
				array_push( $errors, $err );
			} else {
				$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
			}

			//$errors  = array();
			//$this->arf_dig_pro_user_product_listing( $message, $errors );
		}else{
			$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
			array_push( $errors, $err );
		}	
		

		$arf_dig_pro_user_product_data_new = $this->arf_dig_product_user_product_listing( $message, $errors );
		echo json_encode(
			array(
				'errors'   => $errors,
				'message'  => $message,
				'gridData' => $arf_dig_pro_user_product_data_new,
			)
		);
		die();
	}

	function arf_dig_pro_delete_user_product( $id = 0 ) {
		if ( $id == 0 ) {
			return;
		}
		if ( $id ) {
			global $wpdb,$arf_digital_product_download_tbl;
			$res = $wpdb->query( $wpdb->prepare( 'DELETE FROM ' . $arf_digital_product_download_tbl . ' WHERE id = %d', $id ) );
			return $res;
		}
	}

	function arf_dig_pro_get_download_history_entries_list( $download, $as___payment ) {

		if ( empty( $download ) ) {
			return false;
		}

		if ( is_rtl() ) {
			$txt_align = 'arf_digpro_text_align_right';
		} else {
			$txt_align = 'arf_digpro_text_align_left';
		}

		$options = maybe_unserialize( $download->options );

		$var = '<table class="form-table"><tbody>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Download ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->product_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Product ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->product_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Form ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->form_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Entry ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->entry_id . '</td>';
		$var .= '</tr>';

		$txn_id = ( isset( $as___payment[ $download->id ]['txn_id'] ) ) ? $as___payment[ $download->id ]['txn_id'] : '';
		$var   .= '<tr class="arfviewentry_row" valign="top">';
		$var   .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Transaction ID / Subscription ID', 'ARForms-Digital-Product' ) . ':</strong></td>';

		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $txn_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Product Name', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '"><a class="row-title" href="' . wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id={$download->product_id}" ) . '">' . $options['arf_product_name'] . '</a></td>';
		$var .= '</tr>';

		$payment_type = isset( $as___payment[ $download->id ]['payment_type'] ) ? $as___payment[ $download->id ]['payment_type'] : '';
		$var         .= '<tr class="arfviewentry_row" valign="top">';
		$var         .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Type', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var         .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_type . '</td>';
		$var         .= '</tr>';

		$payment_method = isset( $as___payment[ $download->id ]['payment_method'] ) ? $as___payment[ $download->id ]['payment_method'] : '';
		$var           .= '<tr class="arfviewentry_row" valign="top">';
		$var           .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Method', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var           .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_method . '</td>';
		$var           .= '</tr>';

		$currency = ( isset( $as___payment[ $download->id ]['total_amount'] ) && isset( $as___payment[ $download->id ]['currency'] ) ) ? $as___payment[ $download->id ]['total_amount'] . '&nbsp;' . $as___payment[ $download->id ]['currency'] : '';
		$var     .= '<tr class="arfviewentry_row" valign="top">';
		$var     .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Amount', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var     .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $currency . '</td>';
		$var     .= '</tr>';

		$payment_status = isset( $as___payment[ $download->id ]['payment_status'] ) ? $as___payment[ $download->id ]['payment_status'] : '';
		$var           .= '<tr class="arfviewentry_row" valign="top">';
		$var           .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Status', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var           .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_status . '</td>';
		$var           .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Created Date', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . date( get_option( 'date_format' ), strtotime( $download->created_at ) ) . '</td>';
		$var .= '</tr>';

		$var .= '</tbody></table>';
		return $var;
	}
}
