<?php
global $wpdb,$arf_dig_pro_version,$arf_digital_product_download_tbl,$arf_digital_product_tbl;

$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-Digital-Product' );
?>

<div class="wrap paypal_page">
	<div class="top_bar">
		<span class="h2"><?php esc_html_e( 'Manage Products', 'ARForms-Digital-Product' ); ?></span>
	</div>
	<div class="arf_success_message" id="success_message">
		<div class="message_descripiton">
			<div class="success_msg_text arf_digpro_success_msg_text" id="success_msg_text" ></div>
			<div class="message_svg_icon">
				<svg stroke-width="14px" height="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411 l1.616,1.613L6.392,14.407H6.075z"></path>
				</svg>
			</div>
		</div>
	</div>

	<div id="error_message" class="arf_error_message">
		<div class="message_descripiton">
			<div class="error_msg_text arf_digpro_error_msg_text" id="error_msg_text"></div>
			<div style="<?php echo (is_rtl()) ? 'float: right;' : 'float: left;';?> margin-right: 15px;" id="form_error_message_des"></div>
			<div class="message_svg_icon">
				<svg stroke-width="14px" height="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
				</svg>
			</div>
		</div>
	</div>
	<?php echo str_replace( 'id="{arf_id}"', 'id="arf_full_width_loader"', ARF_LOADER_ICON ); ?>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<div class="inside">
				<div class="frm_settings_form wrap_content">
					<div class="arf_digpro_clear_both"></div>
					<form name="arf_dig_pro_forms" method="get" class="arf_digpro_full_width" id="arf_dig_pro_forms" onsubmit="return arf_dig_pro_form_bulk_act();">
						<div id="arf_dig_pro_forms">
							<div class="arf_newaction_rounded_blue_button">
								<button class="rounded_button arf_btn_dark_blue arf_add_new_product_btn" type="button" onclick="location.href = '<?php echo admin_url( 'admin.php?page=ARForms-DigitalProduct&arfaction=new' ); ?>';"><svg width="20px" height="20px" class="arf_digpro_valign_middle"><path  fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M16.997,7.32v2h-7v6.969h-2V9.32h-7v-2h7V0.289h2V7.32H16.997z"></path></svg>&nbsp;	  <?php esc_html_e( 'Add New Product', 'ARForms-Digital-Product' ); ?>
								</button>
							</div>


							<div class="alignleft actions">
								<?php
								$two = '1';
								?>
								 <div class="arf_list_bulk_action_wrapper">
									<input id="arf_bulk_action_one" name="action<?php echo esc_html( $two ); ?>" value="-1" type="hidden" />
									<dl class="arf_selectbox" data-name="action<?php echo esc_html( $two ); ?>" data-id="arf_bulk_action_one">
										<dt>
											<span><?php echo esc_html__( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></span>
											<svg viewBox="0 0 2000 1000" width="15px" height="15px">
												<g fill="#000">
													<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
												</g>
											</svg>
										</dt>
										<dd>
											<ul data-id="arf_bulk_action_one">
												<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></li>
												<?php
													foreach ( $actions as $name => $title ) {
														$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
												?>
														<li <?php echo $class; ?> data-value='<?php echo esc_attr($name); ?>' data-label='<?php echo esc_attr($title); ?>'><?php echo esc_attr( $title ); ?></li>
												<?php } ?>
											</ul>
										</dd>
									</dl>
								</div>
								<input type="submit" id="doaction<?php echo esc_attr($two); ?>" class="arf_bulk_action_btn rounded_button btn_green" value="<?php echo esc_html__( 'Apply', 'ARForms-Digital-Product' ); ?>" />
							</div>



							<table cellpadding="0" cellspacing="0" border="0" class="display table_grid" id="example">
								<thead>
									<tr>
										<th class="center cb-select-all-checkbox">
											<div class="cb-select-all-checkbox-wrapper" >
												<div class="arf_custom_checkbox_div">
													<div class="arf_custom_checkbox_wrapper" >
														<input id="cb-select-all-1" type="checkbox" class="" />
														<svg width="18px" height="18px">
															<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
															<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
														</svg>
													</div>
												</div>
												<label for="cb-select-all-1"  class="cb-select-all">
													<span></span>
												</label>
											</div>
										</th>

										<th class=""><?php esc_html_e( 'Product ID', 'ARForms-Digital-Product' ); ?></th>

										<th class=""><?php esc_html_e( 'Product Name', 'ARForms-Digital-Product' ); ?></th>


										<th class=""><?php esc_html_e( 'Download', 'ARForms-Digital-Product' ); ?></th>
										<th class=""><?php esc_html_e( 'Status', 'ARForms-Digital-Product' ); ?></th>
										<th class=""><?php esc_html_e( 'Created Date', 'ARForms-Digital-Product' ); ?></th>

										<th class="arf_col_action arf_action_cell"><?php esc_html_e( 'Action', 'ARForms-Digital-Product' ); ?></th>
									</tr>
								</thead>
								</tbody>
								<?php


								$products = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'arf_digital_product ORDER BY id DESC' );
								if ( count( $products ) > 0 ) {
									foreach ( $products as $product ) {
										$options = maybe_unserialize( $product->options );


										$product_sales = $wpdb->get_row( $wpdb->prepare( 'SELECT count(product_id) AS toal_sales FROM  ' . $arf_digital_product_download_tbl . ' WHERE product_id = %d', $product->id ) );
										?>
										<tr class="arf_digpro_row">
											<td class="center">
												<div class="arf_custom_checkbox_div">
													<div class="arf_custom_checkbox_wrapper">
														<input id="cb-item-action-<?php echo esc_attr( $product->id ); ?>" class="" type="checkbox" value="<?php echo esc_attr( $product->id ); ?>" name="item-action[]">
														<svg width="18px" height="18px">
															<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
															<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
														</svg>
													</div>
												</div>
												<label for="cb-item-action-<?php echo esc_attr( $product->id ); ?>"><span></span></label></td>
											<td><?php echo esc_html( $product->id ); ?></td>

											<td class="form_name">
												<a class="row-title" href="<?php echo esc_url( wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id=".$product->id ) ); ?>"><?php echo esc_attr( $options['arf_product_name'] ); ?></a>
											</td>

											<td><?php echo esc_html( $product_sales->toal_sales ); ?></td>
											<td><?php echo ( $product->status == 1 ) ? esc_html__( 'Enable', 'ARForms-Digital-Product' ) : esc_html__( 'Disable', 'ARForms-Digital-Product' ); ?></td>
											<td class="center"><?php echo date( get_option( 'date_format' ), strtotime( $product->created_at ) ); ?></td>
											<td class="arf_action_cell">
											<div class="arf-row-actions arf_digpro_no_top_padding">
											<?php
												$edit_link = "?page=ARForms-DigitalProduct&arfaction=edit&id={$product->id}";

												echo "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Product', 'ARForms-Digital-Product' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";

												echo "<div class='arfformicondiv arfhelptip  arfdeleteform_div_" . $product->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  id='delete_product'  data-id='" . $product->id . "' class='arfdeleteproduct arf_digpro_cursor_pointer'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

											?>
												</div>
												</td>
										</tr>
										<?php
									}
								}
								?>
								</tbody>
							</table>

							<div class="clear"></div>
							<input type="hidden" name="show_hide_columns" id="show_hide_columns" value="<?php esc_html_e( 'Show / Hide columns', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="search_grid" id="search_grid" value="<?php esc_html_e( 'Search', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="entries_grid" id="entries_grid" value="<?php esc_html_e( 'entries', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="show_grid" id="show_grid" value="<?php esc_html_e( 'Show', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="showing_grid" id="showing_grid" value="<?php esc_html_e( 'Showing', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="to_grid" id="to_grid" value="<?php esc_html_e( 'to', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="of_grid" id="of_grid" value="<?php esc_html_e( 'of', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="no_match_record_grid" id="no_match_record_grid" value="<?php esc_html_e( 'No matching records found', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="no_record_grid" id="no_record_grid" value="<?php esc_html_e( 'No data available in table', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="filter_grid" id="filter_grid" value="<?php esc_html_e( 'filtered from', 'ARForms-Digital-Product' ); ?>"/>
							<input type="hidden" name="totalwd_grid" id="totalwd_grid" value="<?php esc_html_e( 'total', 'ARForms-Digital-Product' ); ?>"/>

							<div class="alignleft actions2">
								<?php $two = '2'; ?>
								<div class="arf_list_bulk_action_wrapper">
									<input id="arf_bulk_action_one" name="action<?php echo esc_attr($two); ?>" value="-1" type="hidden" />
									<dl class="arf_selectbox" data-name="action<?php echo esc_attr($two); ?>" data-id="arf_bulk_action_one">
										<dt>
											<span><?php echo esc_html__( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></span>
											<svg viewBox="0 0 2000 1000" width="15px" height="15px">
												<g fill="#000">
													<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
												</g>
											</svg>
										</dt>
										<dd>
											<ul data-id="arf_bulk_action_one">
												<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></li>
												<?php
												foreach ( $actions as $name => $title ) {
													$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
												?>
													<li <?php echo $class; ?> data-value='<?php echo esc_attr( $name ); ?>' data-label='<?php echo esc_attr( $title ); ?>'><?php echo esc_attr( $title ); ?></li>
												<?php } ?>
											</ul>
										</dd>
									</dl>
								</div>
								<input type="submit" id="doaction<?php echo esc_attr($two); ?>" class="arf_bulk_action_btn rounded_button btn_green" value="<?php echo esc_html__( 'Apply', 'ARForms-Digital-Product' ); ?>" />
							</div>

							<div class="footer_grid"></div>

						</div>
					</form>
				</div>

				<div id="delete_form_message" class="arfmodal arfhide arffade arfdeletemodabox arf_display_none">
					<div class="arfnewmodalclose" data-dismiss="arfmodal"><img src="<?php echo esc_url( ARFIMAGESURL . '/close-button.png' ); ?>" align="absmiddle" /></div>
					<input type="hidden" value="" id="delete_entry_id"/>
					<div class="arfdelete_modal_title"><img src="<?php echo esc_url( ARFIMAGESURL . '/delete-field-icon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'DELETE', 'ARForms-Digital-Product' ); ?></div>
					<div class="arfdelete_modal_msg"><?php esc_html_e( 'Are you sure you want to delete this product?', 'ARForms-Digital-Product' ); ?></div>
					<div class="arf_delete_modal_row">
						<div class="arf_delete_modal_left" onclick="arf_dig_pro_actionfunc('delete', '');"><img src="<?php echo esc_url( ARFIMAGESURL . '/okay-icon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'Okay', 'ARForms-Digital-Product' ); ?></div>
						<div class="arf_delete_modal_right" data-dismiss="arfmodal"><img src="<?php echo esc_url( ARFIMAGESURL . '/cancel-btnicon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'Cancel', 'ARForms-Digital-Product' ); ?></div>
					</div>
				</div>

				<div class="documentation_link" align="right">
					<a href="<?php echo esc_url( ARF_DIG_PRO_URL ).'/documentation/index.html'; ?>" target="_blank" class="arlinks doc_link"><?php esc_html_e( 'Download Product Documentation', 'ARForms-Digital-Product' ); ?></a>|
					<a href="https://helpdesk.arpluginshop.com/submit-a-ticket/" target="_blank" class="arlinks support_link"><?php esc_html_e( 'Support', 'ARForms-Digital-Product' ); ?></a> &nbsp;&nbsp;
					<img src="<?php echo esc_url( ARFURL.'/images/dot.png' ); ?>" height="4" width="4" onclick="javascript:OpenInNewTab('<?php echo esc_url( ARFURL."/documentation/assets/sysinfo.php"); ?>');" />
				</div>

			</div>
		</div>
	</div>
<div class="arf_modal_overlay">
    <div id="delete_bulk_dig_pro_form_message" class="arfdeletemodabox arfmodal arf_popup_container arfdeletemodalboxnew">
        <input type="hidden" value="false" id="delete_bulk_entry_flag"/>

        <div class="arfdelete_modal_msg delete_confirm_message"><?php echo addslashes(sprintf(esc_html__('Are you sure you want to %s delete selected Form(s)?','ARForms-Digital-Product'),'<br/>')); ?></div>


        <div class="arf_delete_modal_row delete_popup_footer">
            <button class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arf_delete_bulk_dig_pro_form('true');">&nbsp;<?php echo addslashes(esc_html__('Okay', 'ARForms-Digital-Product')); ?></button>&nbsp;&nbsp;<button class="arf_delete_modal_right rounded_button delete_button arfdelete_color_gray arf_bulk_delete_transaction_close_btn" data-dismiss="arfmodal">&nbsp;<?php echo addslashes(esc_html__('Cancel', 'ARForms-Digital-Product')); ?></button>
        </div>
    </div>
</div>