"use strict";

function arf_ChangeID(id) {
	document.getElementById( 'delete_entry_id' ).value = id;
	arfchangedeletemodalwidth( 'arfdeletemodabox' );
}

function arf_dig_pro_actionfunc(act, id) {
	if (act == 'delete') {
		id = document.getElementById( 'delete_entry_id' ).value;
	}
	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			data: "action=arf_dig_pro_delete_product&act=" + act + "&id=" + id,
			dataType:'json',
			beforeSend: function() {
				jQuery( ".arf_loader_icon_wrapper" ).show();
			},
			success: function(msg) {
				jQuery( ".arf_loader_icon_wrapper" ).hide();
				if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				} else {
					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();
					var ProductTableNew = jQuery( '#arf_dig_pro_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [6]
							}, {
								"bSortable": false,
								"aTargets": [0, 6]
							}],
							"oColVis": {
								"aiExclude": [0, 6]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}
				if (jQuery.isFunction( jQuery().tipso )) {
					jQuery( '#arf_dig_pro_forms .arfhelptip' ).tipso(
						{
							position: 'top',
							maxWidth: '400',
							useTitle: true,
							background: '#444444',
							color: '#ffffff'
						}
					);
				}				
			},
			error: function(msg){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
		}
	);
	if (act == 'delete') {
		jQuery( '[data-dismiss="arfmodal"]' ).trigger( "click" );
	}
	return false;
}

function arf_dig_pro_form_bulk_act() {
	var str = jQuery( '#arf_dig_pro_forms' ).serialize();

	var action1 = jQuery("#arf_bulk_action_one").val();
    var action2 = jQuery("#arf_bulk_action_two").val();

    var chk_count = jQuery("input[name='item-action[]']:checked").length;

    var final_action = action1 != '' ? action1 : action2;

    if (final_action == '' || final_action == '-1' || final_action == '-2') {
        jQuery("#form_error_message_des").html(__ARF_VALID_ACTION_DIG_PRO);
        error_msg();
        return false;
    } else if (final_action == 'bulk_delete') {
        if( chk_count == 0 ){
            jQuery("#form_error_message_des").html(__ARF_SELECT_RECORD);
            error_msg();
            return false;
        } else {

            jQuery("#delete_bulk_dig_pro_form_message").addClass('arfactive');
            jQuery("#delete_bulk_dig_pro_form_message").parent('.arf_modal_overlay').addClass('arfactive');
        }
    } else {

	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			beforeSend: function() {
				jQuery( ".arf_loader_icon_wrapper" ).show();
			},
			data: "action=arf_dig_pro_form_bulk_act&" + str,
			dataType:'json',
			success: function(msg) {
				jQuery( ".arf_loader_icon_wrapper" ).hide();
				if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				} else {
					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();
					var ProductTableNew = jQuery( '#arf_dig_pro_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [6]
							}, {
								"bSortable": false,
								"aTargets": [0, 6]
							}],
							"oColVis": {
								"aiExclude": [0, 6]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}

				if (jQuery.isFunction( jQuery().tipso )) {
					jQuery( '#arf_dig_pro_forms .arfhelptip' ).tipso(
						{
							position: 'top',
							maxWidth: '400',
							useTitle: true,
							background: '#444444',
							color: '#ffffff'
						}
					);
				}
			},
			error: function(){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
		}
	);
}
	return false;
}

function arf_dig_pro_save() {
	var req       = 0;
	var arfaction = jQuery( "#arfaction" ).val();
	if (jQuery( '#arf_product_name' ).val() == '') {
		jQuery( '#arf_product_name' ).css( 'border-color', '#ff0000' );
		jQuery( '#arf_product_name_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '#arf_product_name' ).css( 'border-color', '' );
		jQuery( '#arf_product_name_msg' ).css( 'display', 'none' );
	}
	var arfuploadedfile       = jQuery( "input[name=arf_product_file_hidden]" ).val();
	var download_type         = jQuery( "input[name=arf_dig_pro_download_type]:checked" ).val();
	var arfuploadedfilehidden = jQuery( '#arf_pt_import_file_name' ).html().toLowerCase();

	if (download_type == 'internal') {
		if ((arfaction == 'edit' && arfuploadedfile == '' && 'no file selected' != arfuploadedfilehidden) || (arfaction != 'edit' && jQuery( '#arf_pt_import_file' ).val() == '')) {
			jQuery( '#arf_pt_import_file_input' ).css(
				{
					'border-color': '#ff0000'
				}
			);
			jQuery( '#arf_product_file_url_msg' ).css( 'display', 'block' );
			req++;
		} else {
			jQuery( '#arf_pt_import_file_input' ).css(
				{
					'border-color': '#D5E3FF'
				}
			);
			jQuery( '#arf_product_file_url_msg' ).css( 'display', 'none' );
		}
	} else if (download_type == 'external') {
		if (jQuery( '#arf_download_url' ).val() == '') {
			jQuery( '#arf_download_url' ).css(
				{
					'border-color': '#ff0000'
				}
			);
			jQuery( '#arf_download_url_msg' ).css( 'display', 'block' );
			req++;
		} else {
			jQuery( '#arf_download_url' ).css(
				{
					'border-color': ''
				}
			);
			jQuery( '#arf_download_url_msg' ).css( 'display', 'none' );
		}
	}
	if (req > 0) {
		jQuery( window.opera ? 'html' : 'html, body' ).animate(
			{
				scrollTop: jQuery( '#arf_product_name' ).offset().top - 250
			},
			'slow'
		);
		return false;
	} else {
		jQuery( ".arf_dig_product_loader" ).addClass( 'active' );
		var arf_ajaxurl = jQuery( '#arf_ajaxurl' ).val();
		var formData    = new FormData();
		var arfaction   = jQuery( 'input[name="arfaction"]' ).val();
		formData.append( 'action','arf_save_dig_pro_setting' );
		formData.append( '_wpnonce_arfdigpro', jQuery( "#arf_digital_product_nonce" ).val() );
		formData.append( 'arfaction', jQuery( 'input[name="arfaction"]' ).val() );
		if ( 'edit' == arfaction ) {
			formData.append( 'id', jQuery( 'input#product_id' ).val() );
		}
		formData.append( 'arf_product_name', jQuery( 'input[name="arf_product_name"]' ).val() );
		formData.append( 'arf_product_description', jQuery( 'textarea[name="arf_product_description"]' ).val() );
		formData.append( 'arf_product_status', jQuery( 'input[name="arf_product_status"]' ).val() );
		formData.append( 'arf_dig_pro_download_type', jQuery( 'input[name="arf_dig_pro_download_type"]:checked' ).val() );
		formData.append( 'arf_download_url', jQuery( 'input[name="arf_download_url"]' ).val() );
		formData.append( 'arf_product_file_hidden', jQuery( 'input[name="arf_product_file_hidden"]' ).val() );
		formData.append( 'arf_download_note', jQuery( 'textarea[name="arf_download_note"]' ).val() );
		var product_file = jQuery( "#arf_pt_import_file" )[0].files[0];
		formData.append( 'arf_product_file_url', product_file );
		var xhr = new XMLHttpRequest();

		xhr.open( 'POST', arf_ajaxurl, true );

		xhr.send( formData );

		xhr.onreadystatechange = function(e){

			if ( xhr.readyState == 4 && xhr.status == 200 ) {
				var response = jQuery.parseJSON( xhr.responseText );
				jQuery( ".arf_dig_product_loader" ).removeClass( 'active' );
				if ( false == response.error ) {

					jQuery( "#arf_pt_import_file" ).val( '' );
					jQuery( "#arf_pt_import_file_name" ).html( response.file_msg );

					if ( 'new' == response.action ) {
						var pageurl = removeVariableFromURL( document.URL,'arfaction' );
						pageurl    += '&arfaction=edit&id=' + response.id;

						window.history.pushState( {path: pageurl}, '', pageurl );

						jQuery('#arfaction').val('edit');
					}

					jQuery( 'input[name="arfaction"]' ).val( 'edit' );

					jQuery( '#arf_dig_pro_setting_table' ).append( response.arf_product_shortcode );

					if ( 'internal' == response.download_type ) {
						jQuery( '.arf_dig_pro_download_url' ).remove();
						jQuery( '.arf_dig_pro_download_sec' ).append( response.arf_product_file_url );
					}

					jQuery( '#success_msg_text' ).html( response.message );
					success_msg();
				} else {
					jQuery( "#error_msg_text" ).html( response.message );
					error_msg();
				}
			}
		}
		return false;
	}
}

function removeVariableFromURL(url_string, variable_name) {
	var URL   = String( url_string );
	var regex = new RegExp( "\\?" + variable_name + "=[^&]*&?", "gi" );
	URL       = URL.replace( regex, '?' );
	regex     = new RegExp( "\\&" + variable_name + "=[^&]*&?", "gi" );
	URL       = URL.replace( regex, '&' );
	URL       = URL.replace( /(\?|&)$/, '' );
	regex     = null;
	return URL;
}
jQuery( document ).on(
	'click',
	'.arf_product_image',
	function(e) {
		var image_id = jQuery( this ).attr( 'id' );
		jQuery( "#arf_media_upload_iframe" ).remove();
		if (jQuery( "#arf_media_upload_iframeContent" ).html() == "") {
			var iframe_div = document.createElement( 'iframe' );
			iframe_div.setAttribute( 'src', 'media-upload.php?post_id=0&type=image' );
			iframe_div.setAttribute( 'id', 'arf_media_upload_iframe' );
			iframe_div.setAttribute( 'class', 'arf-media-iframe' );
			iframe_div.setAttribute( 'style', 'float:left;width:100%;height:385px;' );
			jQuery( "#arf_media_upload_iframeContent" ).append( iframe_div );
		}
		jQuery( '#arf_dig_pro_images' ).arfmodal(
			{
				show: true
			}
		);
		window.send_to_editor = function(html) {
			var $html   = jQuery(
				'<div />',
				{
					'class': 'media-html',
					'html': html
				}
			);
			var height  = $html.find( 'img' ).attr( 'height' );
			var width   = $html.find( 'img' ).attr( 'width' );
			var img_src = $html.find( 'img' ).attr( 'src' );
			var a_src   = $html.find( 'a' ).attr( 'href' );
			jQuery( 'input.' + image_id ).val( img_src );
			jQuery( '[data-dismiss="arfmodal"]' ).trigger( "click" );
		};
		return false;
	}
);

function arf_delete_close_popup(id) {
	jQuery( '.delete_form_message_' + id ).hide();
	if (jQuery( '.arfdeleteform_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).length > 0) {
		jQuery( '.arfdeleteform_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).remove();
	}
	if (jQuery( '.arfdeleteentry_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).length > 0) {
		jQuery( '.arfdeleteentry_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).remove();
	}
}

jQuery( document ).on(
	'change',
	'#arf_pt_import_file',
	function() {
		var filename = jQuery( this ).val();
		if (filename == "") {
			jQuery( '#arf_pt_import_file_name' ).html(__ARF_NO_FILES_SELECTED);
		} else {
			jQuery( '#arf_pt_import_file_name' ).html( filename );

		}
	}
);
jQuery( document ).ready(
	function() {

		jQuery( "#arf_dig_pro_form" ).change(
			function() {
				var form_id = jQuery( this ).val();
				jQuery.ajax(
					{
						type: "POST",
						url: ajaxurl,
						data: "action=arf_dig_pro_field_dropdown&form_id=" + form_id,
						success: function(msg) {
							jQuery( '.arf_paypal_fields' ).each(
								function(i) {
									var id = jQuery( this ).attr( 'id' );
									if (id != 'undefined' && id != '') {
										var dropdown = msg.split( '^|^' );
										if (dropdown[0] != '' && id == 'arf_product_amount') {
											jQuery( '#' + id ).html( dropdown[0] );
										} else if (dropdown[1] != '' && id != 'arf_product_amount') {
											jQuery( '#' + id ).html( dropdown[1] );
										}
										jQuery( '#' + id ).selectpicker( 'refresh' );
									}
								}
							);
						}
					}
				);
			}
		);
		if (jQuery( '#arf_dig_pro_download_file_data .arf_dig_pro_download_sec' ).length > 1) {
		} else {
				jQuery( '.bulk_add_remove_download_file .bulk_remove' ).hide();
		}
		arf_dig_pro_download_type_show_hide();
		arf_dig_pro_download_list();

		if ( jQuery( '#arp_dig_pro_redirect' ).length > 0 ) {
			window.location.href = jQuery( "#arp_dig_pro_redirect" ).val();
		}

		if ( jQuery( "#arf_digital_product_download_history" ).length > 0 ) {
			arf_load_product_download_history();
		}
	}
);
jQuery( document ).on(
	'click',
	'.arfformentry_delete',
	function(event) {
		var id = jQuery( this ).attr( 'data-id' );
		if (id == null || id == 'undefined') {
			return;
		}
		var delete_popup_html = '';
		delete_popup_html    += '<div class="delete_popup arf_digpro_message arfactive delete_form_message_' + id + '" id="delete_form_message">';
		delete_popup_html    += '<input type="hidden" value="' + id + '" id="delete_entry_id"/>';
		delete_popup_html    += '<div class="delete_column_arrow"></div>';
		delete_popup_html    += '<div class="delete_title"><div class="delete_confirm_message">' + __ARF_DELETE_ENTRY_CONF_MSG + '</div>';
		delete_popup_html    += '<div class="delete_popup_footer">';
		delete_popup_html    += '<button type="button" class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arf_dig_pro_singel_delete(\'delete\',' + id + ');">' + __ARF_DELETE_BUTTON_TEXT + '</button>&nbsp;&nbsp;';
		delete_popup_html    += '<button type="button" class="rounded_button delete_button arfdelete_color_gray" onclick="arf_delete_close_popup(' + id + ');">' + __ARF_CANCEL_BUTTON_TEXT + '</button>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		var select_content    = jQuery( this );
		jQuery( delete_popup_html ).insertAfter( select_content );
		jQuery( '.delete_form_message_' + id ).show();
	}
);
jQuery( document ).on(
	'click',
	'.arfdeleteproduct',
	function(event) {
		var id = jQuery( this ).attr( 'data-id' );
		if (id == null || id == 'undefined') {
			return;
		}
		var delete_popup_html = '';
		delete_popup_html    += '<div class="delete_popup arfactive delete_form_message_' + id + '" id="delete_form_message">';
		delete_popup_html    += '<input type="hidden" value="' + id + '" id="delete_entry_id"/>';
		delete_popup_html    += '<div class="delete_column_arrow"></div>';
		delete_popup_html    += '<div class="delete_title"><div class="delete_confirm_message">' + __ARF_DELETE_ENTRY_CONF_MSG + '</div>';
		delete_popup_html    += '<div class="delete_popup_footer">';
		delete_popup_html    += '<button type="button" class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arf_dig_pro_actionfunc(\'delete\',' + id + ');">' + __ARF_DELETE_BUTTON_TEXT + '</button>&nbsp;&nbsp;';
		delete_popup_html    += '<button type="button" class="rounded_button delete_button arfdelete_color_gray" onclick="arf_delete_close_popup(' + id + ');">' + __ARF_CANCEL_BUTTON_TEXT + '</button>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		var select_content    = jQuery( this );
		jQuery( delete_popup_html ).insertAfter( select_content );
		jQuery( '.delete_form_message_' + id ).show();
	}
);

function arf_dig_pro_user_product_bulk_act() {

	var str = jQuery( '#arf_dig_pro_user_product_forms' ).serialize();

	var action1 = jQuery("#arf_bulk_action_one").val();
    var action2 = jQuery("#arf_bulk_action_two").val();
	var action_delete = jQuery( '#delete_bulk_user_product_flag' ).val();
	var chk_count     = jQuery( 'input[name="item-action[]"]:checked' ).length;
    var final_action = action1 != '' ? action1 : action2;

	if (final_action == '' || final_action == '-1' || final_action == '-2') {
        jQuery("#form_error_message_des").html(__ARF_VALID_ACTION_DIG_PRO);
        error_msg();
        return false;
    } else if (final_action == 'bulk_delete') {
        if( chk_count == 0 ){
            jQuery("#form_error_message_des").html(__ARF_SELECT_RECORD);
            error_msg();
            return false;
        } else {

            jQuery("#delete_bulk_download_pro_form_message").addClass('arfactive');
            jQuery("#delete_bulk_download_pro_form_message").parent('.arf_modal_overlay').addClass('arfactive');
        }
    }else{
    	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			dataType : 'json',
			beforeSend: function() {
				jQuery( ".arf_loader_icon_wrapper" ).show();
			},
			data: "action=arf_dig_pro_user_product_bulk_act&" + str,
			success: function(msg) {
				jQuery( ".arf_loader_icon_wrapper" ).hide();

				if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				} else {
					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_user_product_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();
					var ProductTableNew = jQuery( '#arf_dig_pro_user_product_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [12]
							}, {
								"bSortable": false,
								"aTargets": [0, 12]
							}],
							"oColVis": {
								"aiExclude": [0, 12]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}

				if (jQuery.isFunction( jQuery().tipso )) {
					jQuery( '#arf_dig_pro_user_product_forms .arfhelptip' ).tipso(
						{
							position: 'top',
							maxWidth: '400',
							useTitle: true,
							background: '#444444',
							color: '#ffffff'
						}
					);
				}
			},
			error: function(){
				arf_load_product_download_history( true );
			}
		}
	);

    } 
    if ((action1 == 'bulk_delete' || action2 == 'bulk_delete') && chk_count > 0) {	
	
		if (action_delete == 'false') {
			jQuery( '#delete_bulk_user_product_flag' ).attr( "data-toggle", "arfmodal" ).attr( 'href', '#delete_bulk_user_product_message' ).trigger( "click" );
			return false;
		}
	}

	return false;
}

function arf_dig_pro_delete_bulk_user_product(val) {
	var action_delete = jQuery( '#delete_bulk_user_product_flag' ).val( 'true' );
	jQuery( 'form#arf_dig_pro_user_product_forms' ).submit();
	jQuery( '[data-dismiss="arfmodal"]' ).trigger( "click" );
}

function arf_dig_pro_singel_delete(act, id) {


	if (act == 'delete') {
		id = document.getElementById( 'delete_entry_id' ).value;
	}
	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			dataType:'json',
			data: "action=arf_dig_pro_delete_user_product&act=" + act + "&id=" + id,
			beforeSend: function() {
				jQuery( ".arf_loader_icon_wrapper" ).show();
			},
			success: function(msg) {
				jQuery( ".arf_loader_icon_wrapper" ).hide();
				if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				} else {
					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_user_product_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();
					var ProductTableNew = jQuery( '#arf_dig_pro_user_product_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [12]
							}, {
								"bSortable": false,
								"aTargets": [0, 12]
							}],
							"oColVis": {
								"aiExclude": [0, 12]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}
				if (jQuery.isFunction( jQuery().tipso )) {
					jQuery( '#arf_dig_pro_user_product_forms .arfhelptip' ).tipso(
						{
							position: 'top',
							maxWidth: '400',
							useTitle: true,
							background: '#444444',
							color: '#ffffff'
						}
					);
				}
			},
			error: function(){
				arf_load_product_download_history( true );
			}
		}
	);
	if (act == 'delete') {
		jQuery( '[data-dismiss="arfmodal"]' ).trigger( "click" );
	}
	return false;
}
jQuery( document ).on(
	'click',
	'#arf_dig_pro_internal_type, #arf_dig_pro_external_type',
	function() {
		arf_dig_pro_download_type_show_hide();
	}
);

function arf_dig_pro_download_type_show_hide() {
	var internal_type = jQuery( "input#arf_dig_pro_internal_type:radio:checked" ).val();
	if (internal_type == 'internal') {
		jQuery( ".arf_dig_pro_external_type_data" ).hide();
		jQuery( ".arf_dig_pro_internal_type_data" ).show();
	} else {
		jQuery( ".arf_dig_pro_internal_type_data" ).hide();
		jQuery( ".arf_dig_pro_external_type_data" ).show();
	}
}

function arf_dig_pro_open_entry_thickbox(id) {
	jQuery( "#arf_dig_pro_view_entry_" + id ).arfmodal();
}

function arf_dig_pro_add_file() {
	jQuery( '.bulk_add' ).attr( 'disabled', true );
	var metas = [];
	jQuery( 'input[name^="arf_product_file_url"]' ).each(
		function() {
			metas.push( this.value );
		}
	);
	if (metas.length > 0) {
		var next_meta_id = parseInt( metas.length );
	} else {
		var next_meta_id = 1;
	}
	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			data: "action=add_new_donwload_file&next_file_id=" + next_meta_id,
			success: function(msg) {
				jQuery( '#arf_dig_pro_download_file_data' ).append( msg );
				jQuery( '.bulk_add' ).attr( 'disabled', false );
				if (jQuery( '#arf_dig_pro_download_file_data .arf_dig_pro_download_sec' ).length == 1) {
					jQuery( '.bulk_add_remove_download_file .bulk_remove' ).hide();
				} else {
					jQuery( '.bulk_add_remove_download_file .bulk_remove' ).show();
				}
			}
		}
	);
}

function arf_dig_pro_delete_file(field) {
	if (jQuery( '#arf_dig_pro_download_file_data .arf_dig_pro_download_sec' ).length > 2) {
		jQuery( field ).parents( '.arf_dig_pro_download_sec' ).first().remove();
	} else {
		jQuery( field ).parents( '.arf_dig_pro_download_sec' ).first().remove();
		jQuery( '.bulk_add_remove_download_file .bulk_remove' ).hide();
	}
}

function arf_dig_pro_download_list(is_init) {
	if ('undefined' != typeof jQuery( '#arf_dig_pro_forms' )) {
		is_init = is_init || false;

		jQuery.fn.dataTableExt.oPagination.four_button = {
			"fnInit": function(oSettings, nPaging, fnCallbackDraw) {
				nFirst               = document.createElement( 'span' );
				nPrevious            = document.createElement( 'span' );
				var nInput           = document.createElement( 'input' );
				var nPage            = document.createElement( 'span' );
				var nOf              = document.createElement( 'span' );
				nOf.className        = "paginate_of";
				nInput.className     = "current_page_no";
				nPage.className      = "paginate_page";
				nInput.type          = "text";
				nInput.style.width   = "40px";
				nInput.style.height  = "26px";
				nInput.style.display = "inline";
				nPaging.appendChild( nPage );
				jQuery( nInput ).keyup(
					function(e) {
						if (e.which == 38 || e.which == 39) {
							this.value++;
						} else if ((e.which == 37 || e.which == 40) && this.value > 1) {
							this.value--;
						}
						if (this.value == "" || this.value.match( /[^0-9]/ )) {
							return;
						}
						var iNewStart = oSettings._iDisplayLength * (this.value - 1);
						if (iNewStart > oSettings.fnRecordsDisplay()) {
							oSettings._iDisplayStart = (Math.ceil( (oSettings.fnRecordsDisplay() - 1) / oSettings._iDisplayLength ) - 1) * oSettings._iDisplayLength;
							fnCallbackDraw( oSettings );
							return;
						}
						oSettings._iDisplayStart = iNewStart;
						fnCallbackDraw( oSettings );
					}
				);
				var nNext                          = document.createElement( 'span' );
				var nLast                          = document.createElement( 'span' );
				var nFirst                         = document.createElement( 'span' );
				var nPrevious                      = document.createElement( 'span' );
				var nPage                          = document.createElement( 'span' );
				var nOf                            = document.createElement( 'span' );
				nNext.style.backgroundRepeat       = "no-repeat";
				nNext.style.backgroundPosition     = "center";
				nNext.title                        = "Next";
				nLast.style.backgroundRepeat       = "no-repeat";
				nLast.style.backgroundPosition     = "center";
				nLast.title                        = "Last";
				nFirst.style.backgroundRepeat      = "no-repeat";
				nFirst.style.backgroundPosition    = "center";
				nFirst.title                       = "First";
				nPrevious.style.backgroundRepeat   = "no-repeat";
				nPrevious.style.backgroundPosition = "center";
				nPrevious.title                    = "Previous";
				nFirst.appendChild( document.createTextNode( ' ' ) );
				nPrevious.appendChild( document.createTextNode( ' ' ) );
				nLast.appendChild( document.createTextNode( ' ' ) );
				nNext.appendChild( document.createTextNode( ' ' ) );
				nOf.className = "paginate_button nof";
				nPaging.appendChild( nFirst );
				nPaging.appendChild( nPrevious );
				nPaging.appendChild( nInput );
				nPaging.appendChild( nOf );
				nPaging.appendChild( nNext );
				nPaging.appendChild( nLast );
				jQuery( nFirst ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "first" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nPrevious ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "previous" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nNext ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "next" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nLast ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "last" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nFirst ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nPrevious ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( 'span', nPaging ).bind(
					'mousedown',
					function() {
						return false;
					}
				);
				jQuery( 'span', nPaging ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nNext ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nLast ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
			},
			"fnUpdate": function(oSettings, fnCallbackDraw) {
				if ( ! oSettings.aanFeatures.p) {
					return;
				}
				var an = oSettings.aanFeatures.p;
				for (var i = 0, iLen = an.length; i < iLen; i++) {
					var buttons = an[i].getElementsByTagName( 'span' );
					if (oSettings._iDisplayStart === 0) {
						buttons[1].className = "paginate_disabled_first arfhelptip";
						buttons[2].className = "paginate_disabled_previous arfhelptip";
					} else {
						buttons[1].className = "paginate_enabled_first arfhelptip";
						buttons[2].className = "paginate_enabled_previous  arfhelptip";
					}
					if (oSettings.fnDisplayEnd() == oSettings.fnRecordsDisplay()) {
						buttons[4].className = "paginate_disabled_next  arfhelptip";
						buttons[5].className = "paginate_disabled_last  arfhelptip";
					} else {
						buttons[4].className = "paginate_enabled_next arfhelptip";
						buttons[5].className = "paginate_enabled_last  arfhelptip";
					}
					if ( ! oSettings.aanFeatures.p) {
						return;
					}
					var iPages       = Math.ceil( (oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength );
					var iCurrentPage = Math.ceil( oSettings._iDisplayStart / oSettings._iDisplayLength ) + 1;
					if (document.getElementById( 'of_grid' )) {
						var of_grid = document.getElementById( 'of_grid' ).value;
					} else {
						var of_grid = 'of';
					}
					var an = oSettings.aanFeatures.p;
					for (var i = 0, iLen = an.length; i < iLen; i++) {
						var spans                         = an[i].getElementsByTagName( 'span' );
						var inputs                        = an[i].getElementsByTagName( 'input' );
						spans[spans.length - 3].innerHTML = " " + of_grid + " " + iPages
						inputs[0].value                   = iCurrentPage;
					}
				}
			}
		}
		if ( true == is_init ) {
			var myTable = jQuery( "#arf_dig_pro_forms #example" ).DataTable();
			myTable.fnDestroy();
		}
		var dataTable_instance = jQuery( "#arf_dig_pro_forms #example" );
		dataTable_instance.dataTable(
			{
				"sDom": '<"H"lfr>t<"footer"ip>',
				"sPaginationType": "four_button",
				"bJQueryUI": true,
				"bPaginate": true,
				"bAutoWidth": false,
				"aoColumnDefs": [
				{
					"bVisible": false, "aTargets": []},
				{"bSortable": false, "aTargets": [0, 6]}
				],
				"oColVis": {
					"aiExclude": [0, 6]
				},
			}
		);

		setTimeout(
			function(){
				jQuery( "#arf_full_width_loader" ).hide();
			},
			500
		);
	}
}

jQuery( document ).on(
	".click",
	"#cb-select-all-1",
	function () {
		jQuery( 'input[name="item-action[]"]' ).attr( 'checked', this.checked );
	}
);

jQuery( document ).on(
	'click',
	'input[name="item-action[]"]',
	function () {
		if (jQuery( 'input[name="item-action[]"]' ).length == jQuery( 'input[name="item-action[]"]:checked' ).length) {
			jQuery( "#cb-select-all-1" ).attr( "checked", "checked" );
		} else {
			jQuery( "#cb-select-all-1" ).removeAttr( "checked" );
		}
	}
);

function arf_load_product_download_history(is_init){

	if ('undefined' != typeof jQuery( '#arf_dig_pro_user_product_forms' )) {
		is_init = is_init || false;

		jQuery.fn.dataTableExt.oPagination.four_button = {
			"fnInit": function(oSettings, nPaging, fnCallbackDraw) {
				nFirst               = document.createElement( 'span' );
				nPrevious            = document.createElement( 'span' );
				var nInput           = document.createElement( 'input' );
				var nPage            = document.createElement( 'span' );
				var nOf              = document.createElement( 'span' );
				nOf.className        = "paginate_of";
				nInput.className     = "current_page_no";
				nPage.className      = "paginate_page";
				nInput.type          = "text";
				nInput.style.width   = "40px";
				nInput.style.height  = "26px";
				nInput.style.display = "inline";
				nPaging.appendChild( nPage );
				jQuery( nInput ).keyup(
					function(e) {
						if (e.which == 38 || e.which == 39) {
							this.value++;
						} else if ((e.which == 37 || e.which == 40) && this.value > 1) {
							this.value--;
						}
						if (this.value == "" || this.value.match( /[^0-9]/ )) {
							return;
						}
						var iNewStart = oSettings._iDisplayLength * (this.value - 1);
						if (iNewStart > oSettings.fnRecordsDisplay()) {
							oSettings._iDisplayStart = (Math.ceil( (oSettings.fnRecordsDisplay() - 1) / oSettings._iDisplayLength ) - 1) * oSettings._iDisplayLength;
							fnCallbackDraw( oSettings );
							return;
						}
						oSettings._iDisplayStart = iNewStart;
						fnCallbackDraw( oSettings );
					}
				);
				var nNext                          = document.createElement( 'span' );
				var nLast                          = document.createElement( 'span' );
				var nFirst                         = document.createElement( 'span' );
				var nPrevious                      = document.createElement( 'span' );
				var nPage                          = document.createElement( 'span' );
				var nOf                            = document.createElement( 'span' );
				nNext.style.backgroundRepeat       = "no-repeat";
				nNext.style.backgroundPosition     = "center";
				nNext.title                        = "Next";
				nLast.style.backgroundRepeat       = "no-repeat";
				nLast.style.backgroundPosition     = "center";
				nLast.title                        = "Last";
				nFirst.style.backgroundRepeat      = "no-repeat";
				nFirst.style.backgroundPosition    = "center";
				nFirst.title                       = "First";
				nPrevious.style.backgroundRepeat   = "no-repeat";
				nPrevious.style.backgroundPosition = "center";
				nPrevious.title                    = "Previous";
				nFirst.appendChild( document.createTextNode( ' ' ) );
				nPrevious.appendChild( document.createTextNode( ' ' ) );
				nLast.appendChild( document.createTextNode( ' ' ) );
				nNext.appendChild( document.createTextNode( ' ' ) );
				nOf.className = "paginate_button nof";
				nPaging.appendChild( nFirst );
				nPaging.appendChild( nPrevious );
				nPaging.appendChild( nInput );
				nPaging.appendChild( nOf );
				nPaging.appendChild( nNext );
				nPaging.appendChild( nLast );
				jQuery( nFirst ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "first" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nPrevious ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "previous" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nNext ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "next" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nLast ).click(
					function() {
						oSettings.oApi._fnPageChange( oSettings, "last" );
						fnCallbackDraw( oSettings );
					}
				);
				jQuery( nFirst ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nPrevious ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( 'span', nPaging ).bind(
					'mousedown',
					function() {
						return false;
					}
				);
				jQuery( 'span', nPaging ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nNext ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
				jQuery( nLast ).bind(
					'selectstart',
					function() {
						return false;
					}
				);
			},
			"fnUpdate": function(oSettings, fnCallbackDraw) {
				if ( ! oSettings.aanFeatures.p) {
					return;
				}
				var an = oSettings.aanFeatures.p;
				for (var i = 0, iLen = an.length; i < iLen; i++) {
					var buttons = an[i].getElementsByTagName( 'span' );
					if (oSettings._iDisplayStart === 0) {
						buttons[1].className = "paginate_disabled_first arfhelptip";
						buttons[2].className = "paginate_disabled_previous arfhelptip";
					} else {
						buttons[1].className = "paginate_enabled_first arfhelptip";
						buttons[2].className = "paginate_enabled_previous  arfhelptip";
					}
					if (oSettings.fnDisplayEnd() == oSettings.fnRecordsDisplay()) {
						buttons[4].className = "paginate_disabled_next  arfhelptip";
						buttons[5].className = "paginate_disabled_last  arfhelptip";
					} else {
						buttons[4].className = "paginate_enabled_next arfhelptip";
						buttons[5].className = "paginate_enabled_last  arfhelptip";
					}
					if ( ! oSettings.aanFeatures.p) {
						return;
					}
					var iPages       = Math.ceil( (oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength );
					var iCurrentPage = Math.ceil( oSettings._iDisplayStart / oSettings._iDisplayLength ) + 1;
					if (document.getElementById( 'of_grid' )) {
						var of_grid = document.getElementById( 'of_grid' ).value;
					} else {
						var of_grid = 'of';
					}
					var an = oSettings.aanFeatures.p;
					for (var i = 0, iLen = an.length; i < iLen; i++) {
						var spans                         = an[i].getElementsByTagName( 'span' );
						var inputs                        = an[i].getElementsByTagName( 'input' );
						spans[spans.length - 3].innerHTML = " " + of_grid + " " + iPages
						inputs[0].value                   = iCurrentPage;
					}
				}
			}
		}
		if ( true == is_init ) {
			var myTable = jQuery( "#arf_dig_pro_user_product_forms #example" ).DataTable();
			myTable.fnDestroy();
		}
		var dataTable_instance = jQuery( "#arf_dig_pro_user_product_forms #example" );
		dataTable_instance.dataTable(
			{
				"sDom": '<"H"lfr>t<"footer"ip>',
				"sPaginationType": "four_button",
				"bJQueryUI": true,
				"bPaginate": true,
				"bAutoWidth": false,
				"aoColumnDefs": [
				{"bVisible": false, "aTargets": []},
				{"bSortable": false, "aTargets": [0, 6]}
				],
				"oColVis": {
					"aiExclude": [0, 6]
				},
			}
		);

		setTimeout(
			function(){
				jQuery( "#arf_full_width_loader" ).hide();
			},
			500
		);

		jQuery( "#cb-select-all-1" ).click(
			function () {
				jQuery( 'input[name="item-action[]"]' ).attr( 'checked', this.checked );
			}
		);

		jQuery( 'input[name="item-action[]"]' ).click(
			function () {

				if (jQuery( 'input[name="item-action[]"]' ).length == jQuery( 'input[name="item-action[]"]:checked' ).length) {
					jQuery( "#cb-select-all-1" ).attr( "checked", "checked" );
				} else {
					jQuery( "#cb-select-all-1" ).removeAttr( "checked" );
				}
			}
		);
	}
}

jQuery( document ).on(
	'click',
	'.ColVis_Button:not(.ColVis_MasterButton)',
	function () {
		var colsArray = jQuery( '.ColVis_Button :checkbox' ).map(
			function () {
				return [[jQuery( this ).parent().next( '.ColVis_title' ).text(), this.checked ? 'visibile' : 'hidden']];
			}
		).get();
		var form      = jQuery( '#arfredirecttolist' ).val();
		if (form == '') {
			return false;
		}

		jQuery.ajax(
			{type: "POST", url: ajaxurl, data: "action=managecolumns&colsArray=" + colsArray + "&form=" + form,
				success: function (msg) {
				}
			}
		);
	}
);
function arf_delete_bulk_dig_pro_form(is_delete){

    if( is_delete ){
        var str = jQuery('#arf_dig_pro_forms').serialize();
       
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: "action=arf_dig_pro_form_bulk_act&" + str,
            dataType :'json',
            beforeSend: function() {
                jQuery(".arf_loader_icon_wrapper").show();
            },
            success: function(msg) {
                jQuery(".arf_loader_icon_wrapper").hide();
                if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				}else{

					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();

					var ProductTableNew = jQuery( '#arf_dig_pro_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [6]
							}, {
								"bSortable": false,
								"aTargets": [0, 6]
							}],
							"oColVis": {
								"aiExclude": [0, 6]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}
                jQuery('#arf_dig_pro_forms .arfhelptip').tipso('destroy');

                if (jQuery.isFunction(jQuery().tipso)) {
                    jQuery('#arf_dig_pro_forms .arfhelptip').tipso({
                        position: 'top',
                        width: 'auto',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });
                }
            },
			error: function(msg){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
        }
       );
    }
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
}


function arf_delete_bulk_download_pro_form(is_delete){
    if( is_delete ){
        var str = jQuery('#arf_dig_pro_user_product_forms').serialize();
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            dataType : 'json',
            data: "action=arf_dig_pro_user_product_bulk_act&" + str,
            beforeSend: function() {
                jQuery(".arf_loader_icon_wrapper").show();
            },
            success: function(msg) {
                jQuery(".arf_loader_icon_wrapper").hide();

                if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				}else{
					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_dig_pro_user_product_forms #example" ).DataTable();
					ProductTable.fnClearTable();
					ProductTable.fnDestroy();

					var ProductTableNew = jQuery( '#arf_dig_pro_user_product_forms #example' ).dataTable(
						{
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [12]
							}, {
								"bSortable": false,
								"aTargets": [0, 12]
							}, {
								"sClass": "center cb-select-all-checkbox",
								"aTargets": [0]
							}],
							"oColVis": {
								"aiExclude": [0, 12]
							},
						}
					);
					ProductTableNew.fnAddData( msg.gridData );
				}

                jQuery('#arf_dig_pro_user_product_forms .arfhelptip').tipso('destroy');
                if (jQuery.isFunction(jQuery().tipso)) {
                    jQuery('#arf_dig_pro_user_product_forms .arfhelptip').tipso({
                        position: 'top',
                        width: 'auto',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });
                }
            },error: function(msg){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
        }
        );
    }
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
}


jQuery(document).on('click', '.arf_bulk_delete_transaction_close_btn', function() {
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
});